//include a function
#include <RcppArmadillo.h>

using namespace Rcpp;

// Using a Clever way to set possible default values (similar to the matlab code of Peyré).

int getoptions_int(List& options,  const char* name, int v);

double getoptions_double(List& options,  const char* name, double v);

// Getting a vector in a List. Necessary in order to keep the default
// possibilities.
arma::vec getoptions_vec(List& options,  const char* name, arma::vec v);
// Getting a matrix in a List. Necessary in order to keep the default
// possibilities.
arma::mat getoptions_mat(List& options,  const char* name, arma::mat v);
// Getting a string in a List. Necessary in order to keep the default
// possibilities.
std::string getoptions_string(List& options,  const char* name, const char* v);

// Integer from C to R. Necessary in order to keep the default
// possibilities.
SEXP setInt(int a);
// Double from C to R
SEXP setDouble(double a);
