//include a function
#include <RcppArmadillo.h>

using namespace Rcpp;

double dotp (arma::mat x,arma::mat y){
  double erg = 0;
  erg = sum( vectorise(x)%vectorise(y));
  return(erg);
}

double Entropy(arma::mat x){
  double erg = 0;
  erg = sum(vectorise(x)%(log(vectorise(x)+1e-20)-1) );
  return(erg);
}

// Functions regarding the chosen loss

// L2-loss
arma::mat f_one_L2(arma::mat a){
  a=a%a/2;
  return(a);
}

arma::mat f_two_L2(arma::mat b){
  b = b%b/2;
  return(b);
}

arma::mat h_one_L2(arma::mat a){
  return(a);
}

arma::mat h_two_L2(arma::mat b){
  return(b);
}

// KL-Loss (ckeck def of log for arma::mat!)
arma::mat f_one_KL(arma::mat a){
  a=a%log(a+1e-15)-a;
  return(a);
}

arma::mat f_two_KL(arma::mat b){
  return(b);
}
arma::mat h_one_KL(arma::mat a){
  return(a);
}
arma::mat h_two_KL(arma::mat b){
  return(log(b+1e-15));
}

// Debugging helper

void showMatrix(arma::mat X) {
  Rcout << "Armadillo matrix is" << std::endl << X << std::endl;
}

void showVector(arma::vec X) {
  Rcout << "Armadillo vector is" << std::endl << X << std::endl;
}
